# Copyright (C) 2023 Open Source Robotics Foundation
#
# Licensed under the Apache License, Version 2.0 (the "License")
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# This file is a workaround for a limitation in out protobuf python generation
# where a message that depends on another message will try to import the
# corresponding python module using `gz.msgs` as the package name. However,
# we're installing the python modules in a directory that contains the gz-msgs
# major version number, so the import fails. This hack here overwrites the
# entry for the unversioned module name in `sys.modules` to point to the
# versioned module the first time a message module is loaded. Subsequent
# imports with or without the major version number will work properly.

import sys

unversioned_module = "gz.msgs"
versioned_module = "gz.msgs11"
if unversioned_module in sys.modules:
    print("Looks like you are combining different versions of {}. Found {} and"
          "{} This is not supported".format(sys.modules[unversioned_module],
                                            sys.modules[versioned_module]))
else:
    sys.modules[unversioned_module] = sys.modules[versioned_module]
